# Chapter 1: Foundations
# Odd-numbered problems

setwd("~/Teaching/arm3e/")

# 1.1

qnorm(0.95,lower.tail=T) # 1.644854
1.645*3 + 15 # 19.935

qnorm(0.5,lower.tail=F) # 0
0*3 + 15 # 15

qnorm(0.025,lower.tail=T) # -1.959964
-1.960*3 + 15 # 9.12

1.645*3/sqrt(36) + 15 # 15.8225

0*3/sqrt(36) + 15 # 15

-1.960*3/sqrt(36) + 15 # 14.02

# 1.3 nbasalary: Top 214 2009-10 NBA Guard Salaries at least $100,000

nbasalary <- read.csv("data/nbasalary.csv")
attach(nbasalary)

postscript("insman/nbahist.eps",
           width=3.5, height=3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
hist(Salary, main="", xlab="Salary (2009-2010 salary in thousands of dollars)",
     freq = TRUE,
     breaks=seq(0, 24000, by=2000))
par(oldpar)
dev.off()

postscript("insman/nbaqqplot.eps",
           width=3.0, height=3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
qqnorm(Salary, main="")
qqline(Salary)
par(oldpar)
dev.off()

Logsal <- log(Salary)

postscript("insman/nbahistl.eps",
           width=3.5, height=3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
hist(Logsal, main="",
     xlab="Logsal (natural logarithm of salary)", 
     freq = TRUE,
     breaks=seq(4.5, 10.5, by=.5))
par(oldpar)
dev.off()

postscript("insman/nbaqqplotl.eps",
           width=3.0, height=3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
qqnorm(Logsal, main="")
qqline(Logsal)
par(oldpar)
dev.off()

detach(nbasalary)

# 1.5 nbasalary: Top 214 2009-10 NBA Guard Salaries at least $100,000

nbasalary <- read.csv("data/nbasalary.csv")
attach(nbasalary)

mean(Salary) # 3980.318
sd(Salary) # 4525.378
qt(.975, 213) # 1.971164
1.971*4525.378/sqrt(214) # 609.7258

c(3980.318-609.726, 3980.318+609.726) # 3370.592 4590.044

t.test(Salary, conf.level=.95)
# 95 percent confidence interval:
# 3370.541 4590.094 

mean(Logsal) # 7.664386
sd(Logsal) # 1.197118
exp(mean(Logsal)) # 2131.085
1.971*1.197118/sqrt(214) # 0.1612934

c(7.664386-0.161293, 7.664386+0.161293) # 7.503093 7.825679
exp(c(7.503093, 7.825679)) # 1813.643 2504.086

t.test(Logsal, conf.level=.95)
# 95 percent confidence interval:
# 7.503080 7.825693 
exp(t.test(Logsal, conf.level=.95)$conf.int)
# 1813.619 2504.122

exp(c(7.503093, 7.825679)) - exp(mean(Logsal)) # -317.4416  373.0009

detach(nbasalary)

# 1.7 countries

countries <- read.csv("data/countries.csv")
attach(countries)

n <- dim(countries)[1] # 55

c(mean(Pop), sd(Pop)) # 111.5442 237.2410

c(mean(Life), sd(Life)) # 69.787018  9.250388

qt(.975, n-1) # 2.004879

c(69.787-2.005*9.2504/sqrt(n), 69.787+2.005*9.2504/sqrt(n)) # 67.28612 72.28788

t.test(Life, conf.level=.95)
# 95 percent confidence interval:
#  67.28629 72.28775

detach(countries)

# 1.9 countries

countries <- read.csv("data/countries.csv")
attach(countries)

n <- dim(countries)[1] # 55

mean(Life) # 69.78702
sd(Life) # 9.250388

(69.787-68)/(9.2504/sqrt(n)) # 1.432667

qt(.9, n-1) # 1.297426
qt(.95, n-1) # 1.673565

1-pt(1.43, n-1) # 0.07923887

t.test(Life, mu=68, alternative="greater")
# t = 1.4327, df = 54, p-value = 0.07886

detach(countries)

# 1.11 countries

countries <- read.csv("data/countries.csv")
attach(countries)

n <- dim(countries)[1] # 55

mean(Life) # 69.78702
sd(Life) # 9.250388

qt(.975, n-1) # 2.004879

2.005*9.2504*sqrt(1+1/n) # 18.7149

c(69.787-18.715, 69.787+18.715) # 51.072 88.502

predict(lm(Life~1), interval="prediction")[1,]
#     fit      lwr      upr 
#69.78702 51.07327 88.50077 

detach(countries)

# 1.13

# Part c
qt(0.9,8) # 1.396815
qt(0.95,8) # 1.859548
5.28+c(-1,1)*1.860*0.4/sqrt(9) # 5.032 5.528
(5.28-5)/(0.4/sqrt(9)) # 2.1

# Part d
qt(0.95,15) # 1.75305
qt(0.975,15) # 2.13145
(2.3-2)/(0.6/sqrt(16)) # 2

# Part e
qt(0.9,149) # 1.287259
qt(0.95,149) # 1.655145
(2.94-3)/(0.5/sqrt(150)) # -1.469694
2*pt(-1.47, 150, lower.tail=T) # 0.1436562

# Part f
qt(0.95,27) # 1.703288
qt(0.975,27) # 2.051831
(289280-280000)/(21728/sqrt(28)) # 2.259994