# Chapter 3: Multiple Linear Regression
# Odd-numbered problems

setwd("~/Teaching/arm3e/")

# 3.1 movies

movies <- read.csv("data/movies.csv")
attach(movies)

pairs(cbind(Box,Rate,User,Meta,Len,Win,Nom))

model1 <- lm(Box~Rate+User+Meta)
summary(model1)
#             Estimate Std. Error t value Pr(>|t|)   
#(Intercept) -169.0862    92.0925  -1.836  0.08055 . 
#Rate          35.4962    18.9956   1.869  0.07569 . 
#User           0.4328     0.1472   2.940  0.00783 **
#Meta           1.2462     0.8047   1.549  0.13640   
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 39.53 on 21 degrees of freedom
#Multiple R-squared: 0.8841,	Adjusted R-squared: 0.8675 
#F-statistic: 53.37 on 3 and 21 DF,  p-value: 5.35e-10 

detach(movies)

# 3.3 exams

midterm1 <- c(100, 85, 95, 80, 90, 70)
midterm2 <- c(90, 95, 75, 90, 70, 80)
final <- c(90, 94, 78, 74, 67, 62)

model <- lm(final ~ midterm1 + midterm2)
summary(model)
# Coefficients:
#             Estimate Std. Error t value Pr(>|t|)  
# (Intercept) -65.2181    29.0916  -2.242   0.1108  
# midterm1      0.7234     0.2232   3.241   0.0478 *
# midterm2      0.9602     0.2452   3.916   0.0296 *
# ---
# Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1
#
# Residual standard error: 5.381 on 3 degrees of freedom
# Multiple R-squared:  0.8903,	Adjusted R-squared:  0.8171 
# F-statistic: 12.17 on 2 and 3 DF,  p-value: 0.03635

round(predict(model), 1)
#    1    2    3    4    5    6 
# 93.5 87.5 75.5 79.1 67.1 62.2 

round(-65.218+0.723*midterm1+0.960*midterm2, 1)
# [1] 93.5 87.4 75.5 79.0 67.1 62.2

round(resid(model), 1)
#    1    2    3    4    5    6 
# -3.5  6.5  2.5 -5.1 -0.1 -0.2 

round(final-(-65.218+0.723*midterm1+0.960*midterm2), 1)
# [1] -3.5  6.6  2.5 -5.0 -0.1 -0.2

sum(resid(model)^2) # 86.85312

rss <- sum((final-(-65.218+0.723*midterm1+0.960*midterm2))^2)
rss # 86.87343

sqrt(sum(resid(model)^2)/(6-3)) # 5.380617

sqrt(rss/(6-3)) # 5.381246

mean(final) # 77.5

round(final-mean(final), 1)
# 12.5  16.5   0.5  -3.5 -10.5 -15.5

tss <- sum((final-mean(final))^2)
tss # 791.5

1-sum(resid(model)^2)/tss # 0.8902677

1-rss/tss # 0.890242

# 3.5 movies

movies <- read.csv("data/movies.csv")
attach(movies)

model1 <- lm(Box~Rate+User+Meta)
model0 <- lm(Box ~ 1)
anova(model0, model1)
#  Res.Df    RSS Df Sum of Sq      F   Pr(>F)    
#1     24 283097                                 
#2     21  32823  3    250274 53.375 5.35e-10 ***

model2 <- lm(Box~Rate+User+Meta+Len+Win+Nom)
anova(model0, model2)
#Model 1: Box ~ ones - 1
#Model 2: Box ~ Rate + User + Meta + Len + Win + Nom
#  Res.Df    RSS Df Sum of Sq      F    Pr(>F)    
#1     24 283097                                  
#2     18  32435  6    250662 23.184 1.505e-07 ***

((32823-32435)/3)/(32435/18) # 0.07177432
qf(0.95,3,18) # 3.159908
pf(0.072,3,18,lower.tail=F) # 0.9742075

anova(model1, model2)
#  Res.Df   RSS Df Sum of Sq      F Pr(>F)
#1     21 32823                           
#2     18 32435  3    387.66 0.0717 0.9744

summary(model1)$sigma # 39.53477
summary(model2)$sigma # 42.44952
summary(model1)$adj.r.squared # 0.8674944
summary(model2)$adj.r.squared # 0.8472359

detach(movies)

# 3.7 major league soccer

(0.914/3) / ((1-0.914)/(12-3-1)) # 28.34109
qf(0.95,3,8) # 4.066181
pf(28.3,3,8,lower.tail=F) # 0.0001305827