# Chapter 5: Regression Model Building II

setwd("~/Teaching/arm3e/")

# 5.1 Influential points

# cars5

cars5 <- read.csv("data/cars5.csv")
attach(cars5)

cars5[rep(1:25,rep(2,25))+rep(c(0,25),25),2:6]
#                                  Name Cmpg Eng Cyl  Vol
#1                 Aston Martin DB9 5.9L   13 5.9  12 0.83
#26           Hyundai Genesis Coupe 3.8L   17 3.8   6 0.99
#2              BMW 128Ci Convertible 3L   18 3.0   6 0.86
#27                   Infiniti EX35 3.5L   17 3.5   6 1.11
#3                           BMW 128i 3L   18 3.0   6 0.96
#28                    Infiniti G25 2.5L   20 2.5   6 1.13
#4                          BMW 328Ci 3L   18 3.0   6 1.00
#29        Infiniti G37 Convertible 3.7L   17 3.7   6 0.88
#5              BMW 328Ci Convertible 3L   18 3.0   6 0.93
#30                    Infiniti M37 3.7L   18 3.7   6 1.19
#6                           BMW 328i 3L   18 3.0   6 1.05
#31                         Jaguar XJ 5L   15 5.0   8 1.20
#7              BMW 328i Sports Wagon 3L   18 3.0   6 1.18
#32                   Lexus HS 250h 2.4L   35 2.4   4 1.02
#8              BMW 335Ci Convertible 3L   19 3.0   6 0.93
#33                    Lexus LS 460 4.6L   16 4.6   8 1.17
#9              BMW 335is Convertible 3L   17 3.0   6 0.93
#34                  Mercedes C 350 3.5L   17 3.5   6 1.00
#10                   BMW 335is Coupe 3L   17 3.0   6 1.00
#35      Mercedes E 350 Convertible 3.5L   17 3.5   6 0.86
#11           BMW 550i Gran Turismo 4.4L   15 4.4   8 1.22
#36            Mercedes E 350 Coupe 3.5L   17 3.5   6 0.92
#12                          BMW 740i 3L   17 3.0   6 1.20
#37                  Mercedes E 550 4.7L   15 4.7   8 1.11
#13                         BMW 740Li 3L   17 3.0   6 1.29
#38      Mercedes E 550 Convertible 5.5L   15 5.5   8 0.86
#14                        BMW 750i 4.4L   15 4.4   8 1.20
#39            Mercedes E 550 Coupe 5.5L   15 5.5   8 0.92
#15                    Cadillac CTS 3.6L   18 3.6   6 1.14
#40                Mercedes GLK 350 3.5L   16 3.5   6 1.26
#16                      Cadillac CTS 3L   18 3.0   6 1.14
#41                 Mercedes ML 350 3.5L   16 3.5   6 1.48
#17              Cadillac CTS Wagon 3.6L   18 3.6   6 1.26
#42                  Mercedes S 550 5.5L   15 5.5   8 1.25
#18                Cadillac CTS Wagon 3L   18 3.0   6 1.26
#43                     Nissan 370Z 3.7L   19 3.7   6 0.59
#19                Chevrolet Camaro 3.6L   18 3.6   6 1.04
#44            Nissan 370Z Roadster 3.7L   18 3.7   6 0.56
#20                Chrysler 300 FFV 3.6L   18 3.6   6 1.22
#45             Porsche 911 Carrera 3.6L   19 3.6   6 0.75
#21            Dodge Challenger FFV 3.6L   18 3.6   6 1.07
#46   Porsche 911 Carrera Cabriolet 3.6L   19 3.6   6 0.73
#22           Dodge Challenger SRT8 6.4L   14 6.4   8 1.07
#47 Porsche 911 Carrera S Cabriolet 3.8L   19 3.8   6 0.73
#23               Dodge Charger FFV 3.6L   18 3.6   6 1.20
#48         Porsche 911 Turbo Coupe 3.8L   17 3.8   6 0.75
#24                 Hyundai Genesis 3.8L   18 3.8   6 1.25
#49                Porsche Panamera 3.6L   18 3.6   6 1.23
#25             Hyundai Genesis Coupe 2L   20 2.0   4 0.99
#50               Rolls-Royce Ghost 6.6L   13 6.6  12 1.25

# 5.1.1 Outliers

Cgphm <- 100/Cmpg
model1 <- lm(Cgphm ~ Eng + Cyl + Vol, x=T)
round(coef(summary(model1)),3)
#            Estimate Std. Error t value Pr(>|t|)
#(Intercept)    2.542      0.365   6.964    0.000
#Eng            0.235      0.112   2.104    0.041
#Cyl            0.294      0.076   3.855    0.000
#Vol            0.476      0.279   1.709    0.094

plot(model1)

rstu1 <- rstudent(model1)
min(rstu1) # -8.273863
which.min(rstu1) # 32
cars5[32,]
#    ID               Name Cmpg Eng Cyl  Vol
# 32 32 Lexus HS 250h 2.4L   35 2.4   4 1.02

postscript("manuscript/figures/cars5hist1.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
hist(rstu1,main="",
     xlab="Studentized residual",
     breaks=16,
     ylab="")
text(-7.5, 1.5, "Lexus HS 250h")
par(oldpar)
dev.off()

sort(abs(rstu1),T)[c(1,2,3)]
#       32       50       40 
# 8.273863 1.720862 1.434280 

detach(cars5)
cars5x <- cars5[-32,]
attach(cars5x)

Cgphm <- 100/Cmpg
model2 <- lm(Cgphm ~ Eng + Cyl + Vol)
round(coef(summary(model2)),3)
#            Estimate Std. Error t value Pr(>|t|)
#(Intercept)    2.905      0.237  12.281    0.000
#Eng            0.259      0.071   3.645    0.001
#Cyl            0.228      0.049   4.634    0.000
#Vol            0.492      0.177   2.774    0.008

round(abs(100*(coef(model2)/coef(model1)-1)),1)
#(Intercept)         Eng         Cyl         Vol 
#       14.3        10.4        22.4         3.4 
round(mean(abs(100*(coef(model2)/coef(model1)-1))),1)
# 12.6
round(mean(abs(100*(coef(model2)/coef(model1)-1))[2:4]),1)
# 12.1

plot(model2)

rstu2 <- rstudent(model2)

plot(Eng,rstu2)
plot(Cyl,rstu2)
plot(Vol,rstu2)
plot(fitted(model2),rstu2)

postscript("manuscript/figures/cars5hist2.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
hist(rstu2,main="",
     xlab="Studentized residual",
     breaks=seq(-2.5,2.5, length=11),
     ylab="")
par(oldpar)
dev.off()

sort(abs(rstu2),T)[c(1,2,3)]
#       28       39        9 
# 2.171550 1.978154 1.621589  

# 5.1.2 Leverage

lev2 <- hatvalues(model2)

plot(ID, lev2, xlab="ID number", ylab="Leverage")
identify(ID, lev2) # 1 22 49

2*(3+1)/49 # 0.1632653
3*(3+1)/49 # 0.244898

cars5x[c(1,49,22),]
#    ID                       Name Cmpg Eng Cyl  Vol
# 1   1      Aston Martin DB9 5.9L   13 5.9  12 0.83
# 50 50     Rolls-Royce Ghost 6.6L   13 6.6  12 1.25
# 22 22 Dodge Challenger SRT8 6.4L   14 6.4   8 1.07

plot(Eng,Cyl)
identify(Eng,Cyl) #  1 22 49

plot(Eng,Vol)
identify(Eng,Vol) #  1 22 49

sort(lev2,T)[c(1,2,3)]
#         1        49        22 
# 0.4908441 0.3497482 0.3144375 

postscript("manuscript/figures/cars5lev1.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(ID, lev2, xlab="ID number", ylab="Leverage")
abline(2*(3+1)/49,0,lty=2)
abline(3*(3+1)/49,0,lty=2)
text(ID[1]+8, lev2[1], "Aston Martin DB9")
text(ID[22]-11, lev2[22], "Dodge Challenger SRT8")
text(ID[49]-9, lev2[49], "Rolls-Royce Ghost")
par(oldpar)
dev.off()

detach(cars5x)
cars5xx <- cars5x[-1,]
attach(cars5xx)

Cgphm <- 100/Cmpg
model3 <- lm(Cgphm ~ Eng + Cyl + Vol)
round(coef(summary(model3)),3)
#            Estimate Std. Error t value Pr(>|t|)
#(Intercept)    2.949      0.247  11.931    0.000
#Eng            0.282      0.080   3.547    0.001
#Cyl            0.201      0.064   3.139    0.003
#Vol            0.532      0.188   2.824    0.007

round(abs(100*(coef(model3)/coef(model2)-1)),1)
#(Intercept)         Eng         Cyl         Vol 
#        1.5         8.8        11.8         8.0 
round(mean(abs(100*(coef(model3)/coef(model2)-1))), 1)
# 7.5
round(mean(abs(100*(coef(model3)/coef(model2)-1))[2:4]),1)
# 9.5

# 5.1.3 Cook's distance

detach(cars5xx)
attach(cars5)

coo1 <- cooks.distance(model1)

plot(ID, coo1, xlab="ID number", ylab="Cook's distance")
identify(ID, coo1) # 32 50

cars5[c(32,50),]
#    ID                   Name Cmpg Eng Cyl  Vol
# 32 32     Lexus HS 250h 2.4L   35 2.4   4 1.02
# 50 50 Rolls-Royce Ghost 6.6L   13 6.6  12 1.25

sort(coo1,T)[c(1,2,3)]
#         32         50          1 
# 0.63299910 0.35684945 0.07211824 

postscript("manuscript/figures/cars5coo1.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(ID, coo1, xlab="ID number", ylab="Cook's distance")
abline(.5,0,lty=2)
text(ID[32]-7, coo1[32], "Lexus HS 250h")
#text(ID[50]-9, coo1[50], "Rolls-Royce Ghost")
par(oldpar)
dev.off()

detach(cars5)
attach(cars5x)

coo2 <- cooks.distance(model2)

plot(ID, coo2, xlab="ID number", ylab="Cook's distance")
identify(ID, coo2) # 1 22 49

cars5x[c(49,22,1),]
#    ID                       Name Cmpg Eng Cyl  Vol
# 50 50     Rolls-Royce Ghost 6.6L   13 6.6  12 1.25
# 22 22 Dodge Challenger SRT8 6.4L   14 6.4   8 1.07
# 1   1      Aston Martin DB9 5.9L   13 5.9  12 0.83

sort(coo2,T)[c(1,2,3)]
#        49        22        28 
# 0.2670947 0.1501340 0.1250393 

postscript("manuscript/figures/cars5coo2.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(ID, coo2, xlab="ID number",
     ylim=c(0,.6),
     ylab="Cook's distance")
abline(.5,0,lty=2)
text(ID[1]+8, coo2[1], "Aston Martin DB9")
text(ID[22]+11, coo2[22], "Dodge Challenger SRT8")
text(ID[49]-9, coo2[49], "Rolls-Royce Ghost")
par(oldpar)
dev.off()

detach(cars5x)
attach(cars5)

lev1 <- hatvalues(model1)

Name[32] # Lexus HS 250h 2.4L
round(c(rstu1[32],lev1[32],coo1[32]),2)
# -8.27  0.08  0.63 - high res, low lev, high coo

Name[1] # Aston Martin DB9 5.9L
round(c(rstu1[1],lev1[1],coo1[1]),2)
# -0.56  0.47  0.07 - low res, high lev, low coo

Name[50] # Rolls-Royce Ghost 6.6L
round(c(rstu1[50],lev1[50],coo1[50]),2)
# -1.72  0.33  0.36 - med res, med lev, med coo

Name[22] # Dodge Challenger SRT8 6.4L
round(c(rstu1[22],lev1[22],coo1[22]),2)
# 0.75 0.31 0.07 - low res, med lev, low coo

detach(cars5)
attach(cars5x)

Name[1] # Aston Martin DB9 5.9L
round(c(rstu2[1],lev2[1],coo2[1]),2)
# 0.66 0.49 0.11 - low res, high lev, low coo

Name[49] # Rolls-Royce Ghost 6.6L
round(c(rstu2[49],lev2[49],coo2[49]),2)
# -1.43  0.35  0.27 - med res, med lev, med/low coo

Name[22] # Dodge Challenger SRT8 6.4L
round(c(rstu2[28],lev2[28],coo2[28]),2)
# -2.17  0.10  0.13 - high/med res, low lev, low coo

detach(cars5x)

# Check formulas

res1 <- residuals(model1)
rsta1 <- rstandard(model1)

dfr <- summary(model1)$df[1]
dfe <- summary(model1)$df[2]
s <- summary(model1)$sigma

# check rstandard formula
round(rsta1-res1/(s*sqrt(1-lev1)),10) # 0s

# check rstudent formula
round(rstu1-(rsta1*sqrt((dfe-1)/(dfe-rsta1^2))),10) # 0s

# check hatvalues formulas
round(lev1-diag(model1$x %*% solve(t(model1$x) %*% model1$x) %*% t(model1$x)),10) # 0s
round(lev1-dfr*coo1/(dfr*coo1+rsta1^2),10) # 0s

# check cook.distance formula
round(coo1-rsta1^2*lev1/(dfr*(1-lev1)),10) # 0s

# 5.2 Regression pitfalls

# 5.2.1 Nonconstant variance

# fertility

fertility <- read.csv("data/fertility.csv")
attach(fertility)

pairs(cbind(Fer, Inc, Edu))

logInc <- log(Inc)

pairs(cbind(Fer, logInc, Edu))

model1 <- lm(Fer ~ logInc + Edu)
summary(model1)
#            Estimate Std. Error t value Pr(>|t|)    
#(Intercept)  5.58302    0.18356  30.415  < 2e-16 ***
#logInc      -0.40770    0.08457  -4.821 3.21e-06 ***
#Edu         -0.21743    0.02968  -7.325 9.85e-12 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.8589 on 166 degrees of freedom
#Multiple R-squared: 0.6732,	Adjusted R-squared: 0.6693 
#F-statistic:   171 on 2 and 166 DF,  p-value: < 2.2e-16 

rstu1 <- rstudent(model1)

postscript("manuscript/figures/fertility1.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(fitted(model1), rstu1, xlab="Fitted values", ylab="Studentized residual",
	ylim=c(-2.7,2.7))
par(oldpar)
dev.off()

# Breusch-Pagan Cook-Weisberg test

library(car)
ncvTest(model1)
#Non-constant Variance Score Test 
#Variance formula: ~ fitted.values 
#Chisquare = 15.78616    Df = 1     p = 7.091946e-05 

library(lmtest)
bptest(model1, varformula = ~ fitted(model1), studentize=F)
#BP = 15.786, df = 1, p-value = 7.092e-05

logFer <- log(Fer)

model2 <- lm(logFer ~ logInc + Edu)
summary(model2)
#             Estimate Std. Error t value Pr(>|t|)    
#(Intercept)  1.790882   0.059233  30.235  < 2e-16 ***
#logInc      -0.148200   0.027289  -5.431 1.97e-07 ***
#Edu         -0.064182   0.009578  -6.701 3.08e-10 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.2771 on 166 degrees of freedom
#Multiple R-squared: 0.6718,	Adjusted R-squared: 0.6679 
#F-statistic: 169.9 on 2 and 166 DF,  p-value: < 2.2e-16 

rstu2 <- rstudent(model2)

postscript("manuscript/figures/fertility2.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(fitted(model2), rstu2, xlab="Fitted values", ylab="Studentized residual",
	ylim=c(-2.7,2.7))
par(oldpar)
dev.off()

ncvTest(model2)
#Non-constant Variance Score Test 
#Variance formula: ~ fitted.values 
#Chisquare = 0.01886714    Df = 1     p = 0.89075 

bptest(model2, varformula = ~ fitted(model2), studentize=F)
#BP = 0.018867, df = 1, p-value = 0.8907

detach(fertility)

# 5.2.2 Autocorrelation

# unemp

unemp <-read.csv("data/unemp.csv")
attach(unemp)

plot(Time, Unr, type="l")
plot(Time, Bms, type="l")
plot(Time, Ipd, type="l")

Mop <- Bms/Ipd

plot(Time, Mop, type="l")

plot(Time, Gdp, type="l")
plot(Time, Exp, type="l")

hist(Mop)
hist(Gdp)
hist(Exp)

LMop <- log(Mop)
LGdp <- log(Gdp)
LExp <- log(Exp)

hist(LMop)
hist(LGdp)
hist(LExp)

model1<-lm(Unr ~ LMop + LGdp + LExp + Time)
summary(model1)
#            Estimate Std. Error t value Pr(>|t|)    
#(Intercept) 215.0559    28.0334   7.671 7.91e-10 ***
#LMop         10.9233     2.9772   3.669  0.00062 ***
#LGdp        -29.5200     4.3503  -6.786 1.73e-08 ***
#LExp         -1.3197     2.0788  -0.635  0.52862    
#Time          0.7333     0.1504   4.875 1.28e-05 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 1.028 on 47 degrees of freedom
#Multiple R-squared: 0.5879,	Adjusted R-squared: 0.5529 
#F-statistic: 16.77 on 4 and 47 DF,  p-value: 1.325e-08 

plot(fitted(model1), Unr, ylim=c(1,13), xlim=c(1,13))
lines(sort(fitted(model1)),predict(model1, interval="prediction")[order(fitted(model1)),2])
lines(sort(fitted(model1)),predict(model1, interval="prediction")[order(fitted(model1)),3])

resid1 <- residuals(model1)

postscript("manuscript/figures/unemp1.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(Time, resid1, xlab="Time period", ylab="Residual",
     ylim = c(-2.3, 2.3))
par(oldpar)
dev.off()

n <- nrow(unemp)

# first-order autocorrelation
resid1[-n]%*%resid1[-1]/resid1%*%resid1 # 0.8740254

# Wald-Wolfowitz Runs Test

library(tseries)
resid1p <- factor(ifelse(resid1>0,1,0))
runs.test(resid1p)
# Standard Normal = -4.4777, p-value = 7.544e-06
# alternative hypothesis: two.sided 

# Durbin-Watson test

sum((resid1[-1]-resid1[-n])^2)/resid1%*%resid1 # 0.2433496

library(car)
dwt(model1, alternative="positive")
# lag Autocorrelation D-W Statistic p-value
#   1       0.8740254     0.2433496       0
# Alternative hypothesis: rho > 0

library(lmtest)
dwtest(model1)
#DW = 0.24335, p-value < 2.2e-16
#alternative hypothesis: true autocorrelation is greater than 0 

# Breusch-Godfrey LM test

lagr1 <- c(0,resid1[-n])

model1a <- lm(resid1 ~ LMop + LGdp + LExp + Time + lagr1)
summary(model1a)
#            Estimate Std. Error t value Pr(>|t|)    
#(Intercept) 26.80144   12.77604   2.098  0.04145 *  
#LMop         2.77630    1.35606   2.047  0.04636 *  
#LGdp        -5.38052    1.99838  -2.692  0.00986 ** 
#LExp         1.80908    0.94549   1.913  0.06193 .  
#Time        -0.01322    0.06774  -0.195  0.84608    
#lagr1        0.91706    0.06728  13.630  < 2e-16 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.4631 on 46 degrees of freedom
#Multiple R-squared: 0.8015,	Adjusted R-squared:  0.78 
#F-statistic: 37.16 on 5 and 46 DF,  p-value: 4.6e-15 

n*summary(model1a)$r.squared
# 41.67971

bgtest(model1)
# LM test = 41.68, df = 1, p-value = 1.075e-10
bgtest(model1, order=2)
# LM test = 41.868, df = 2, p-value = 8.099e-10

# Include lag response as a predictor

lagUnr <- Unr[-n]
Unr1 <- Unr[-1]
LMop1 <- LMop[-1]
LGdp1 <- LGdp[-1]
LExp1 <- LExp[-1]
Time1 <- Time[-1]

model2<-lm(Unr1 ~ LMop1 + LGdp1 + LExp1 + Time1 + lagUnr)
summary(model2)
#             Estimate Std. Error t value Pr(>|t|)    
#(Intercept) 144.67081   21.00906   6.886 1.50e-08 ***
#LMop1         8.55370    2.16111   3.958 0.000266 ***
#LGdp1       -21.67952    3.07483  -7.051 8.57e-09 ***
#LExp1         1.23629    1.49928   0.825 0.413955    
#Time1         0.39253    0.11749   3.341 0.001686 ** 
#lagUnr        0.59648    0.07691   7.755 7.84e-10 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.6858 on 45 degrees of freedom
#Multiple R-squared: 0.8242,	Adjusted R-squared: 0.8046 
#F-statistic: 42.18 on 5 and 45 DF,  p-value: 6.843e-16 

plot(fitted(model2),Unr1)

resid2 <- residuals(model2)
plot(Time1, resid2, type="l")
plot(Time1, resid2)

bgtest(model2)
# LM test = 11.129, df = 1, p-value = 0.0008498

# First differences procedure

lagLMop <- LMop[-n]
lagLGdp <- LGdp[-n]
lagLExp <- LExp[-n]
lagtr <- Time[-n]
difUnr <- Unr[-1]-lagUnr
difLMop <- LMop[-1]-lagLMop
difLGdp <- LGdp[-1]-lagLGdp
difLExp <- LExp[-1]-lagLExp
diftr <- Time[-1]-lagtr

model3 <- lm(difUnr ~ difLMop + difLGdp + difLExp + diftr - 1)
summary(model3)
#        Estimate Std. Error t value Pr(>|t|)    
#difLMop   4.3724     2.3620   1.851   0.0704 .  
#difLGdp -32.8640     2.6874 -12.229 3.30e-16 ***
#difLExp  -5.2232     1.2050  -4.335 7.64e-05 ***
#diftr     1.2690     0.1217  10.423 8.26e-14 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.4096 on 47 degrees of freedom
#Multiple R-squared: 0.8432,	Adjusted R-squared: 0.8299 
#F-statistic: 63.19 on 4 and 47 DF,  p-value: < 2.2e-16 

plot(fitted(model3),difUnr)

plot(fitted(model3),difUnr, ylim=c(-3,5), xlim=c(-3,5))
lines(sort(fitted(model3)),predict(model3, interval="prediction")[order(fitted(model3)),2])
lines(sort(fitted(model3)),predict(model3, interval="prediction")[order(fitted(model3)),3])

resid3 <- residuals(model3)
plot(Time[-1], resid3, type="l")
plot(Time[-1], resid3)

postscript("manuscript/figures/unemp2.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(Time[-1], resid3, xlab="Time period", ylab="Residual",
     ylim = c(-1.1, 1.1))
par(oldpar)
dev.off()

model3a <- lm(difUnr ~ difLMop + difLGdp + difLExp + diftr)

resid3a <- residuals(model3a)

resid3a[-(n-1)]%*%resid3a[-1]/resid3a%*%resid3a
# 0.0008902402 autocorrelation

sum((resid3a[-1]-resid3a[-(n-1)])^2)/resid3a%*%resid3a
# 1.949132 dw test statistic

dwt(model3a, alternative="positive")
# lag Autocorrelation D-W Statistic p-value
#   1    0.0008902402      1.949132   0.378

dwtest(model3a)
# DW = 1.9491, p-value = 0.2628

bgtest(model3)
# LM test = 4.6405e-05, df = 1, p-value = 0.9946

# Cochrane-Orcutt procedure

model1c <- lm(resid1[-1] ~ resid1[-n] - 1)
model1c <- lm(resid1 ~ lagr1 - 1)
summary(model1c)
#      Estimate Std. Error t value Pr(>|t|)    
#lagr1  0.87816    0.06767   12.98   <2e-16 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.476 on 51 degrees of freedom
#Multiple R-squared: 0.7675,	Adjusted R-squared: 0.763 
#F-statistic: 168.4 on 1 and 51 DF,  p-value: < 2.2e-16 

rhohat <- c(resid1[-n]%*%resid1[-1]/resid1%*%resid1) # 0.8740254 autocorrelation

coUnr <- Unr[-1]-rhohat*lagUnr
coLMop <- LMop[-1]-rhohat*lagLMop
coLGdp <- LGdp[-1]-rhohat*lagLGdp
coLExp <- LExp[-1]-rhohat*lagLExp
cotr <- Time[-1]-rhohat*lagtr

model4 <- lm(coUnr ~ coLMop + coLGdp + coLExp + cotr)
summary(model4)
#            Estimate Std. Error t value Pr(>|t|)    
#(Intercept)  35.9483     2.3723  15.154  < 2e-16 ***
#coLMop        2.8385     2.4099   1.178    0.245    
#coLGdp      -32.6761     2.6292 -12.428 2.62e-16 ***
#coLExp       -5.6967     1.2283  -4.638 2.93e-05 ***
#cotr          1.2582     0.1056  11.912 1.17e-15 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.3898 on 46 degrees of freedom
#Multiple R-squared: 0.8514,	Adjusted R-squared: 0.8384 
#F-statistic: 65.87 on 4 and 46 DF,  p-value: < 2.2e-16 

plot(fitted(model4),coUnr)

resid4 <- residuals(model4)

resid4[-(n-1)]%*%resid4[-1]/resid4%*%resid4
# -0.01018523 autocorrelation

sum((resid4[-1]-resid4[-(n-1)])^2)/resid4%*%resid4
# 1.954576 dw test statistic

dwt(model4, alternative="positive")
# lag Autocorrelation D-W Statistic p-value
#   1     -0.01018523      1.954576    0.33
# Alternative hypothesis: rho > 0

dwtest(model4)
# DW = 1.9546, p-value = 0.3202

plot(Time[-1], resid4, type="l")
plot(Time[-1], resid4)

bgtest(model4)
# LM test = 0.0059909, df = 1, p-value = 0.9383

detach(unemp)

# 5.2.3 Multicollinearity

# sales3

sales3 <- read.csv("data/sales3.csv") 
attach(sales3)

model1 <- lm(Sales ~ Trad + Int)

summary(model1)
#            Estimate Std. Error t value Pr(>|t|)  
#(Intercept)   1.9921     0.9016   2.210   0.0545 .
#Trad          1.2748     0.7367   1.730   0.1176  
#Int           0.7672     0.8683   0.884   0.3999  
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.8916 on 9 degrees of freedom
#Multiple R-squared: 0.974,	Adjusted R-squared: 0.9682 
#F-statistic: 168.5 on 2 and 9 DF,  p-value: 7.386e-08 

round(summary(model1)$coef, 3)
#             Estimate Std. Error t value Pr(>|t|)
# (Intercept)    1.992      0.902   2.210    0.054
# Trad           1.275      0.737   1.730    0.118
# Int            0.767      0.868   0.884    0.400

library(car)
vif(model1)
#   Trad     Int 
#49.5409 49.5409 

cor(Sales,Trad) # 0.9857635
cor(Sales,Int) # 0.9825124 
cor(Trad,Int) # 0.9898559

TpI <- Trad + Int

model2 <- lm(Sales ~ TpI)
summary(model2)
#            Estimate Std. Error t value Pr(>|t|)    
#(Intercept)  1.77568    0.56191    3.16   0.0102 *  
#TpI          1.04189    0.05415   19.24 3.13e-09 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.8505 on 10 degrees of freedom
#Multiple R-squared: 0.9737,	Adjusted R-squared: 0.9711 
#F-statistic: 370.2 on 1 and 10 DF,  p-value: 3.134e-09 

round(summary(model2)$coef, 3)
#             Estimate Std. Error t value Pr(>|t|)
# (Intercept)    1.776      0.562    3.16     0.01
# TpI            1.042      0.054   19.24     0.00

# VIF calculation
1/(1-summary(lm(Trad~Int))$r.squared) # 49.5409

detach(sales3)

# 5.2.4 Excluding important predictor variables

# paradox

paradox <- read.csv("data/paradox.csv")
attach(paradox)

model1 <- lm(Quality ~ Speed)
summary(model1)
#            Estimate Std. Error t value Pr(>|t|)   
#(Intercept)   2.8469     1.0108   2.817  0.00934 **
#Speed         0.4296     0.1878   2.288  0.03089 * 
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 2.128 on 25 degrees of freedom
#Multiple R-squared: 0.1731,	Adjusted R-squared:  0.14 
#F-statistic: 5.233 on 1 and 25 DF,  p-value: 0.03089 

round(coef(summary(model1)),3)
#            Estimate Std. Error t value Pr(>|t|)
#(Intercept)    2.847      1.011   2.817    0.009
#Speed          0.430      0.188   2.288    0.031

postscript("manuscript/figures/paradox1.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(Speed, Quality, xlab="Speed",
     ylab="Quality")
par(oldpar)
dev.off()

model2 <- lm(Quality ~ Speed + Angle)
summary(model2)
#            Estimate Std. Error t value Pr(>|t|)    
#(Intercept)  1.63839    0.21696   7.551 8.63e-08 ***
#Speed       -0.96190    0.07105 -13.539 9.89e-13 ***
#Angle        2.01400    0.08580  23.473  < 2e-16 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.4436 on 24 degrees of freedom
#Multiple R-squared: 0.9655,	Adjusted R-squared: 0.9626 
#F-statistic: 335.7 on 2 and 24 DF,  p-value: < 2.2e-16 

round(coef(summary(model2)),3)
#            Estimate Std. Error t value Pr(>|t|)
#(Intercept)    1.638      0.217   7.551        0
#Speed         -0.962      0.071 -13.539        0
#Angle          2.014      0.086  23.473        0

postscript("manuscript/figures/paradox2.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(Speed, Quality, xlab="Speed",
     ylab="Quality", type="n")
for (i in 1:27)
  points(Speed[i], Quality[i], pch=as.character(Angle[i]))
legend("bottomright", legend="Points marked by Angle",
       inset = .02, x.intersp = 0, cex = .9)
par(oldpar)
dev.off()

detach(paradox)

# 5.2.5 Overfitting

# overfit

x <- c(-0.9, -0.4, -0.1, 0.1, 0.4, 0.9)
y <- c(0.99, 4.45, 4.85, 5.78, 7.99, 9.31)

postscript("manuscript/figures/overfit1.eps",
           width = 2.5, height = 2.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(x,y,xlab="X",ylab="Y",xlim=c(-1,1),ylim=c(-2,10))
lines(x,fitted(lm(y~x)))
par(oldpar)
dev.off()

predict(lm(y~x), newdata=data.frame(x=-0.6)) # 2.807483

postscript("manuscript/figures/overfit2.eps",
           width = 2.5, height = 2.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(x,y,xlab="X",ylab="Y",xlim=c(-1,1),ylim=c(-2,10))
lines(seq(-1,1,.05),
      predict(lm(y~x+I(x^2)+I(x^3)+I(x^4)+I(x^5)),
              data.frame(x=seq(-1,1,.05))))
par(oldpar)
dev.off()

predict(lm(y~x+I(x^2)+I(x^3)+I(x^4)+I(x^5)), newdata=data.frame(x=-0.6)) # 4.185032

# 5.2.6 Extrapolation

# extrapex

extrapex <- read.csv("data/extrapex.csv")
attach(extrapex)

model1 <- lm(Y ~ X)
summary(model1)

model2 <- lm(Y ~ X + Xsq)
summary(model2)

postscript("manuscript/figures/extrapex.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(X,Yact,xlab="Labor = labor hours in 100s", type="n",
     ylab="Production = production in 100s",
     xlim=c(2,12), ylim=c(5,25))
points(X,Y)
points(X[31:32],Yact[31:32], pch=4)
newX <- seq(min(X[1:30]),max(X[1:30]),length=100)
newXsq <- newX^2
lines(newX, predict(model1, data.frame(X=newX)))
lines(newX, predict(model2, data.frame(X=newX, Xsq=newXsq)))
newXX <- seq(max(X[1:30]),max(X[31:32]),length=100)
newXXsq <- newXX^2
lines(newXX, predict(model1, data.frame(X=newXX)), lty=2)
lines(newXX, predict(model2, data.frame(X=newXX, Xsq=newXXsq)), lty=2)
par(oldpar)
dev.off()

detach(extrapex)

# 5.2.7 Missing data

# missing

missing <- read.csv("data/missing.csv")
attach(missing)

model1 <- lm(Y ~ X1 + X2 + X3 + X4)
summary(model1)
#            Estimate Std. Error t value Pr(>|t|)    
#(Intercept) -0.21860    0.55788  -0.392   0.6993    
#X1           0.06986    0.14402   0.485   0.6329    
#X2           0.24544    0.13110   1.872   0.0759 .  
#X3           0.92455    0.08559  10.802 8.52e-10 ***
#X4           0.96902    0.12240   7.917 1.37e-07 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.8649 on 20 degrees of freedom
#  (5 observations deleted due to missingness)
#Multiple R-squared: 0.9586,	Adjusted R-squared: 0.9503 
#F-statistic: 115.8 on 4 and 20 DF,  p-value: 1.564e-13 

round(coef(summary(model1)),3)
#            Estimate Std. Error t value Pr(>|t|)
#(Intercept)   -0.219      0.558  -0.392    0.699
#X1             0.070      0.144   0.485    0.633
#X2             0.245      0.131   1.872    0.076
#X3             0.925      0.086  10.802    0.000
#X4             0.969      0.122   7.917    0.000

model2 <- lm(Y ~ X2 + X3 + X4)
summary(model2)
#            Estimate Std. Error t value Pr(>|t|)    
#(Intercept) -0.22402    0.54752  -0.409  0.68657    
#X2           0.28583    0.09940   2.875  0.00905 ** 
#X3           0.92579    0.08398  11.024 3.42e-10 ***
#X4           0.99546    0.10759   9.252 7.42e-09 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.849 on 21 degrees of freedom
#  (5 observations deleted due to missingness)
#Multiple R-squared: 0.9581,	Adjusted R-squared: 0.9521 
#F-statistic: 160.1 on 3 and 21 DF,  p-value: 1.261e-14 

round(coef(summary(model2)),3)
#            Estimate Std. Error t value Pr(>|t|)
#(Intercept)   -0.224      0.548  -0.409    0.687
#X2             0.286      0.099   2.875    0.009
#X3             0.926      0.084  11.024    0.000
#X4             0.995      0.108   9.252    0.000

model3 <- lm(Y ~ X1 + X3 + X4)
summary(model3)
#            Estimate Std. Error t value Pr(>|t|)    
#(Intercept)  0.20891    0.49272   0.424   0.6752    
#X1           0.23708    0.10917   2.172   0.0396 *  
#X3           0.96611    0.07401  13.054 1.16e-12 ***
#X4           0.94298    0.11121   8.480 8.00e-09 ***
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 0.8524 on 25 degrees of freedom
#  (1 observation deleted due to missingness)
#Multiple R-squared: 0.9529,	Adjusted R-squared: 0.9472 
#F-statistic: 168.4 on 3 and 25 DF,  p-value: < 2.2e-16 

round(coef(summary(model3)),3)
#            Estimate Std. Error t value Pr(>|t|)
#(Intercept)    0.209      0.493   0.424    0.675
#X1             0.237      0.109   2.172    0.040
#X3             0.966      0.074  13.054    0.000
#X4             0.943      0.111   8.480    0.000

detach(missing)

# 5.4 Model selection

simulate <- read.csv("data/simulate.csv")
attach(simulate)

D1X2 <- D1*X2
D1X3 <- D1*X3
D1X4 <- D1*X4
D1X5 <- D1*X5
D1X6 <- D1*X6
D1X7 <- D1*X7

X2sq <- X2^2
X3sq <- X3^2
X4sq <- X4^2
X5sq <- X5^2
X6sq <- X6^2
X7sq <- X7^2

pairs(cbind(Y,X2,X3,X4,X5,X6,X7))
plot(X4+X5,X6)

model1 <- lm(Y ~ D1 + X2 + X3 + X4 + X5 + X6 + X7
             + D1X2 + D1X3 + D1X4 + D1X5 + D1X6 + D1X7
             + X2sq + X3sq + X4sq + X5sq + X6sq + X7sq)
summary(model1)
#Residual standard error: 1.037 on 80 degrees of freedom
#Multiple R-squared: 0.7899,	Adjusted R-squared:  0.74 
#F-statistic: 15.83 on 19 and 80 DF,  p-value: < 2.2e-16 

n <- nrow(simulate)
dfr1 <- summary(model1)$df[1] # k+1
dfe1 <- summary(model1)$df[2] # n-k-1
s1 <- summary(model1)$sigma
arsq1 <- summary(model1)$adj.r.squared

cat(dfr1-1,                                     # k
    round(dfe1*s1^2, 1),                        # RSS
    round(s1,3),                                # s
    round(arsq1,3),                             # Adj-RSq
    round(n*log(dfe1*s1^2/n) + 2*dfr1, 2),      # AIC
    round(n*log(dfe1*s1^2/n) + log(n)*dfr1, 1), # BIC
    round((dfe1*s1^2)/s1^2 + 2*dfr1 - n, 2))    # Cp
# 19 86 1.037 0.74 24.88 77 20

model2 <- lm(Y ~ D1 + X2 + X3 + X4 + X5 + X6 + D1X2 + X3sq)

dfr2 <- summary(model2)$df[1] # k+1
dfe2 <- summary(model2)$df[2] # n-k-1
s2 <- summary(model2)$sigma
arsq2 <- summary(model2)$adj.r.squared

cat(dfr2-1,                                     # k
    round(dfe2*s2^2, 1),                        # RSS
    round(s2,3),                                # s
    round(arsq2,3),                             # Adj-RSq
    round(n*log(dfe2*s2^2/n) + 2*dfr2, 2),      # AIC
    round(n*log(dfe2*s2^2/n) + log(n)*dfr2, 1), # BIC
    round((dfe2*s2^2)/s1^2 + 2*dfr2 - n, 2))    # Cp
# 8 87.4 0.98 0.768 4.57 28 -0.63

model3 <- lm(Y ~ D1 + X2 + X3 + X4 + X5 + X7 + D1X2 + X3sq)

dfr3 <- summary(model3)$df[1] # k+1
dfe3 <- summary(model3)$df[2] # n-k-1
s3 <- summary(model3)$sigma
arsq3 <- summary(model3)$adj.r.squared

cat(dfr3-1,                                     # k
    round(dfe3*s3^2, 1),                        # RSS
    round(s3,3),                                # s
    round(arsq3,3),                             # Adj-RSq
    round(n*log(dfe3*s3^2/n) + 2*dfr3, 2),      # AIC
    round(n*log(dfe3*s3^2/n) + log(n)*dfr3, 1), # BIC
    round((dfe3*s3^2)/s1^2 + 2*dfr3 - n, 2))    # Cp
# 8 87.9 0.983 0.766 5.07 28.5 -0.23

model4 <- lm(Y ~ D1 + X2 + X3 + X4 + X5 + D1X2 + X3sq)

dfr4 <- summary(model4)$df[1] # k+1
dfe4 <- summary(model4)$df[2] # n-k-1
s4 <- summary(model4)$sigma
arsq4 <- summary(model4)$adj.r.squared

cat(dfr4-1,                                     # k
    round(dfe4*s4^2, 1),                        # RSS
    round(s4,3),                                # s
    round(arsq4,3),                             # Adj-RSq
    round(n*log(dfe4*s4^2/n) + 2*dfr4, 2),      # AIC
    round(n*log(dfe4*s4^2/n) + log(n)*dfr4, 1), # BIC
    round((dfe4*s4^2)/s1^2 + 2*dfr4 - n, 2))    # Cp
# 7 88.2 0.979 0.768 3.45 24.3 -1.92

model5 <- lm(Y ~ D1 + X2 + X3 + X6 + D1X2 + X3sq)

dfr5 <- summary(model5)$df[1] # k+1
dfe5 <- summary(model5)$df[2] # n-k-1
s5 <- summary(model5)$sigma
arsq5 <- summary(model5)$adj.r.squared

cat(dfr5-1,                                     # k
    round(dfe5*s5^2, 1),                        # RSS
    round(s5,3),                                # s
    round(arsq5,3),                             # Adj-RSq
    round(n*log(dfe5*s5^2/n) + 2*dfr5, 2),      # AIC
    round(n*log(dfe5*s5^2/n) + log(n)*dfr5, 1), # BIC
    round((dfe5*s5^2)/s1^2 + 2*dfr5 - n, 2))    # Cp
# 6 89.3 0.98 0.768 2.63 20.9 -2.94

detach(simulate)

# 5.5 Predictor effect plots

# creditcard

creditcard <- read.csv("data/creditcard.csv")
attach(creditcard)

plot(Purch,Bal,type="n")
for(i in 1:50) points(Purch[i],Bal[i],pch=as.character(DR[i]))

plot(Purch,Bal,type="n")
for(i in 1:50) points(Purch[i],Bal[i],pch=as.character(DM[i]))

plot(House,Bal,type="n")
for(i in 1:50) points(House[i],Bal[i],pch=as.character(DR[i]))

plot(House,Bal,type="n")
for(i in 1:50) points(House[i],Bal[i],pch=as.character(DM[i]))

DRPurch <- DR*Purch
DRHouse <- DR*House
DMPurch <- DM*Purch
DMHouse <- DM*House
Purchsq <- Purch^2
Housesq <- House^2

model1 <- lm(Bal ~ DR + DM + Purch + House + DRPurch + DRHouse
             + DMPurch + DMHouse + Purchsq + Housesq)
summary(model1)
#            Estimate Std. Error t value Pr(>|t|)    
#(Intercept)  62.0535    36.3722   1.706 0.095949 .  
#DR          -39.5410    35.8909  -1.102 0.277346    
#DM          -37.7002    25.4208  -1.483 0.146098    
#Purch        18.3528     5.8909   3.115 0.003438 ** 
#House       -15.2903     8.5251  -1.794 0.080641 .  
#DRPurch       3.5368     4.2301   0.836 0.408192    
#DRHouse      17.7893     4.1128   4.325 0.000102 ***
#DMPurch       2.9943     3.3870   0.884 0.382088    
#DMHouse       2.3254     3.3621   0.692 0.493239    
#Purchsq      -1.3642     0.5703  -2.392 0.021659 *  
#Housesq       0.6733     0.7029   0.958 0.344056    
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 16.16 on 39 degrees of freedom
#Multiple R-squared: 0.9052,	Adjusted R-squared: 0.8809 
#F-statistic: 37.25 on 10 and 39 DF,  p-value: < 2.2e-16 

round(coef(summary(model1)),3)
#            Estimate Std. Error t value Pr(>|t|)
#(Intercept)   62.053     36.372   1.706    0.096
#DR           -39.541     35.891  -1.102    0.277
#DM           -37.700     25.421  -1.483    0.146
#Purch         18.353      5.891   3.115    0.003
#House        -15.290      8.525  -1.794    0.081
#DRPurch        3.537      4.230   0.836    0.408
#DRHouse       17.789      4.113   4.325    0.000
#DMPurch        2.994      3.387   0.884    0.382
#DMHouse        2.325      3.362   0.692    0.493
#Purchsq       -1.364      0.570  -2.392    0.022
#Housesq        0.673      0.703   0.958    0.344

model2 <- lm(Bal ~ DR + DM + Purch + House + DRHouse + Purchsq)
summary(model2)
#            Estimate Std. Error t value Pr(>|t|)    
#(Intercept)  19.0936    21.1757   0.902 0.372253    
#DR          -23.9185    18.5307  -1.291 0.203686    
#DM          -10.6769     4.6833  -2.280 0.027639 *  
#Purch        18.6267     4.7913   3.888 0.000346 ***
#House        -5.3349     2.5953  -2.056 0.045929 *  
#DRHouse      17.5786     3.2895   5.344 3.26e-06 ***
#Purchsq      -0.9220     0.4567  -2.019 0.049781 *  
#---
#Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1 

#Residual standard error: 16.03 on 43 degrees of freedom
#Multiple R-squared: 0.8972,	Adjusted R-squared: 0.8828 
#F-statistic: 62.53 on 6 and 43 DF,  p-value: < 2.2e-16 

round(coef(summary(model2)),3)
#            Estimate Std. Error t value Pr(>|t|)
#(Intercept)   19.094     21.176   0.902    0.372
#DR           -23.919     18.531  -1.291    0.204
#DM           -10.677      4.683  -2.280    0.028
#Purch         18.627      4.791   3.888    0.000
#House         -5.335      2.595  -2.056    0.046
#DRHouse       17.579      3.289   5.344    0.000
#Purchsq       -0.922      0.457  -2.019    0.050

anova(model2,model1)
#  Res.Df   RSS Df Sum of Sq      F Pr(>F)
#1     43 11046                           
#2     39 10180  4    866.17 0.8296 0.5145

(sum(residuals(model2)^2)-sum(residuals(model1)^2))/4 /
  (sum(residuals(model1)^2)/39) # F = 0.8295704
pf(0.8295704,4,39,lower.tail=F) # 0.5145406

cor(Bal,fitted(model1)) # 0.9514356
cor(Bal,fitted(model2)) # 0.9471886

round(coef(model2),2)
#(Intercept)          DR          DM       Purch       House     DRHouse     Purchsq 
#      19.09      -23.92      -10.68       18.63       -5.33       17.58       -0.92 

mean(House) # 5.598 
coef(model2)[5]*mean(House) # -29.86484 
k1 <- c(coef(model2) %*% c(1, 0, 0, 0, mean(House), 0, 0)) # -10.77124
coef(model2)[4] # 18.62667
coef(model2)[7] # -0.9219667

Purcheffect <- k1 + coef(model2)[4]*Purch + coef(model2)[7]*Purchsq

postscript("manuscript/figures/creditcardx1.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(sort(Purch), Purcheffect[order(Purch)],
     xlab="Purch = purchases ($ hundreds)",
     ylab="Purch effect on Bal (average monthly balance)", type="l")
par(oldpar)
dev.off()

(coef(model2)[4]*3 + coef(model2)[7]*3^2) -
  (coef(model2)[4]*2 + coef(model2)[7]*2^2) # 14.01683

(coef(model2)[4]*9 + coef(model2)[7]*9^2) -
  (coef(model2)[4]*8 + coef(model2)[7]*8^2) # 2.953234

mean(Purch) # 4.665
coef(model2)[4]*mean(Purch) # 86.8934
coef(model2)[7]*mean(Purch)^2 # -20.06405 
k2 <- c(coef(model2)[1]+coef(model2)[4]*mean(Purch)+
          coef(model2)[7]*mean(Purch)^2) # 85.92296
coef(model2)[2] # -23.91851
coef(model2)[5] # -5.334913
coef(model2)[6] # 17.5786

Houseeffect <- k2 + coef(model2)[2]*DR + coef(model2)[5]*House +
  coef(model2)[6]*DRHouse
Houseeffect0 <- Houseeffect[DR==0]
Houseeffect1 <- Houseeffect[DR==1]

postscript("manuscript/figures/creditcardx2.eps",
           width = 4.0, height = 3.0, pointsize = 8,
           horizontal = FALSE, onefile = FALSE, paper = "special")
oldpar <- par(mar=c(3,3,1,1)+0.1, mgp=c(2,1,0))
plot(House, Houseeffect,
     xlab="House = housing costs ($ hundreds)",
     ylab="House effect on Bal (average monthly balance)", type="n")
lines(sort(House[DR==0]), Houseeffect0[order(House[DR==0])])
text(7,139,"renter")
lines(sort(House[DR==1]), Houseeffect1[order(House[DR==1])])
text(7,57,"homeowner")
par(oldpar)
dev.off()

k2 + coef(model2)[2] # 62.00445
coef(model2)[5] + coef(model2)[6] # 12.24369

detach(creditcard)