# Chapter 7: Extensions
# Odd-numbered problems

setwd("~/Teaching/arm3e/")

# 7.1 phone

phone <- read.csv("data/phone.csv")
attach(phone)

model1 <- glm(Purch ~ Male + Score, family="binomial")
summary(model1)
# Coefficients:
#             Estimate Std. Error z value Pr(>|z|)    
# (Intercept) -27.6739     6.1887  -4.472 7.76e-06 ***
# Male          2.3053     0.7675   3.004  0.00267 ** 
# Score         3.1598     0.7271   4.346 1.39e-05 ***
# ---
# Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1
# 
# (Dispersion parameter for binomial family taken to be 1)
# 
# Null deviance: 126.030  on 98  degrees of freedom
# Residual deviance:  64.866  on 96  degrees of freedom
# AIC: 70.866

round(exp(coef(model1)),3)
# (Intercept)        Male       Score 
#       0.000      10.027      23.566 

exp(coef(model1) %*% c(1, 0, 8)) # 0.09113668
exp(coef(model1) %*% c(1, 1, 8)) # 0.9138148
exp(coef(model1) %*% c(1, 0, 9)) # 2.147749

exp(predict(model1, newdata=data.frame(Male=0, Score=8))) # 0.09113668
exp(predict(model1, newdata=data.frame(Male=1, Score=8))) # 0.9138148
exp(predict(model1, newdata=data.frame(Male=1, Score=8))) /
  exp(predict(model1, newdata=data.frame(Male=0, Score=8))) # 10.02686

exp(predict(model1, newdata=data.frame(Male=0, Score=9))) # 2.147749
exp(predict(model1, newdata=data.frame(Male=0, Score=9))) /
  exp(predict(model1, newdata=data.frame(Male=0, Score=8))) # 23.56624

predict(model1, newdata=data.frame(Male=0, Score=9), type="response") # 0.6823127
2.147749 / (1 + 2.147749) # 0.6823127

summary(model1)$null.deviance-summary(model1)$deviance # 61.16414
summary(model1)$df.null-summary(model1)$df.residual # 2

round(pchisq(summary(model1)$null.deviance-summary(model1)$deviance,
             summary(model1)$df.null-summary(model1)$df.residual,
             lower.tail=F), 3)
# 0

table(Purch, fitted(model1)>0.5)
# Purch FALSE TRUE
#     0    61    5
#     1    10   23

plot(Score, predict(model1, type="response"), type="n")
points(sort(Score), jitter(Purch[order(Score)], 0.2), pch=Male)
lines(sort(Score[Male==0]), 
      predict(model1, type="response")[Male==0][order(Score[Male==0])], lty=1)
lines(sort(Score[Male==1]), 
      predict(model1, type="response")[Male==1][order(Score[Male==1])], lty=2)

detach(phone)
